//Titel:           5. Vorlesungsuebung
//Version:          1,0
//Copyright:        Copyright (c) 2013
//Autor:            M. Wilhelm
//Organisation:     HS-Harz
//Beschreibung:     BorderLayout mit SplitPane

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import java.util.*;

public class Aufgabe05 extends JFrame implements ActionListener {

	final int MAXITEMS = 100000; // 1000000

	public static final long serialVersionUID = 1;

	JSpinner anzThread;
	JComboBox dataMining;

	// global fuer addActionListener
	JButton bnCreate1 = new JButton("Create 1");
	JButton bnCreateN = new JButton("Create Thread");
	JButton bnDataMining1 = new JButton("DataMining 1");
	JButton bnDataMiningN = new JButton("DataMining Thread");
	JButton bnMerge = new JButton("Merge");
	JButton bnClose = new JButton("Close");

	JTextArea editor = new JTextArea();

	Middleware middleware = new Middleware();

	public Aufgabe05() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setGUI();
	}

	private void setGUI() {
		setSize(800, 450);
		setTitle("05. Tutorial");

		this.getContentPane().setLayout(new GridBagLayout());

		JPanel panelBn = new JPanel();
		panelBn.setLayout(new GridLayout(6, 1));
		panelBn.add(bnCreate1);
		panelBn.add(bnCreateN);
		panelBn.add(bnDataMining1);
		panelBn.add(bnDataMiningN);
		panelBn.add(bnMerge);
		panelBn.add(bnClose);

		this.getContentPane().add(
				panelBn,
				new GridBagConstraints(4, 1, 1, 3, 0.0, 100.0,
						GridBagConstraints.WEST, GridBagConstraints.VERTICAL,
						new Insets(20, 20, 20, 20), 0, 0));

		this.getContentPane().add(
				new JLabel("Anz Thread"),
				new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
						GridBagConstraints.WEST, GridBagConstraints.NONE,
						new Insets(20, 20, 20, 0), 0, 0));

		SpinnerNumberModel model1 = new SpinnerNumberModel(10, 0, 100, 1);
		anzThread = new JSpinner(model1);

		this.getContentPane().add(
				anzThread,
				new GridBagConstraints(1, 1, 1, 1, 80.0, 0.0,
						GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
						new Insets(20, 20, 20, 0), 0, 0));

		this.getContentPane().add(
				new JLabel("Data Mining"),
				new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0,
						GridBagConstraints.WEST, GridBagConstraints.NONE,
						new Insets(20, 20, 20, 0), 0, 0));

		Vector<String> liste = new Vector<>();
		liste.add("EDV");
		liste.add("Elektronik");
		liste.add("Telefon");
		liste.add("Handy");
		liste.add("Kleidung");
		liste.add("TV");
		liste.add("LCD");
		liste.add("Ernhrung");
		liste.add("Schuhe");
		liste.add("Kleidung");
		liste.add("Mbel");
		liste.add("Blumen");
		liste.add("Bcher");
		Collections.sort(liste);
		dataMining = new JComboBox(liste);
		anzThread = new JSpinner(model1);

		this.getContentPane().add(
				dataMining,
				new GridBagConstraints(3, 1, 1, 1, 80.0, 0.0,
						GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
						new Insets(20, 20, 20, 20), 0, 0));

		this.getContentPane().add(
				new JLabel("Ergebnisse"),
				new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0,
						GridBagConstraints.WEST, GridBagConstraints.NONE,
						new Insets(20, 20, 0, 0), 0, 0));

		this.getContentPane().add(
				new JScrollPane(editor),
				new GridBagConstraints(0, 3, 4, 1, 100.0, 100.0,
						GridBagConstraints.WEST, GridBagConstraints.BOTH,
						new Insets(10, 20, 20, 20), 0, 0));

		editor.setFont(new Font("Arial", Font.PLAIN, 18));
		
		setFonts(getContentPane(), 18);

		bnCreate1.addActionListener(this);
		bnCreateN.addActionListener(this);
		bnDataMining1.addActionListener(this);
		bnDataMiningN.addActionListener(this);
		bnMerge.addActionListener(this);
		bnClose.addActionListener(this);
	} // setGUI

	private void setFonts(Container cont, int size) {
		for (int i = 0; i < cont.getComponentCount(); i++) {
			Component c = cont.getComponent(i);
			if (c instanceof JPanel)
				setFonts((JPanel) c, size);
			else
				c.setFont(new Font("Arial", Font.BOLD, size));
		}
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == bnCreate1) {
			bnCreate1_click();
		}
		if (e.getSource() == bnCreateN) {
			bnCreateN_click();
		}

		if (e.getSource() == bnDataMining1) {
			bnDataMining1_click();
		}
		if (e.getSource() == bnDataMiningN) {
			bnDataMiningN_click();
		}

		if (e.getSource() == bnMerge) {
			bnMerge_click();
		}

		if (e.getSource() == bnClose) {
			System.exit(0);
		}
	}

	private void bnCreate1_click() {
		middleware.Create1_Files(editor, MAXITEMS, getAnzThread());
	}

	private int getAnzThread() {
		return ((Integer) anzThread.getValue()).intValue();
	}

	private void bnCreateN_click() {
		middleware.CreateN_Files(editor, MAXITEMS, getAnzThread());
	}

	private void bnDataMining1_click() {
		middleware.DataMining1(editor, getAnzThread(),
				(String) dataMining.getSelectedItem());
	}

	private void bnDataMiningN_click() {
		middleware.DataMiningN(editor, getAnzThread(),	(String) dataMining.getSelectedItem());
	}

	private void bnMerge_click() {
		middleware.Merge_Files(editor, getAnzThread());
	}

	public static void main(String[] args) {
		Aufgabe05 frame = new Aufgabe05();
		frame.setVisible(true);
	}

} // Aufgabe05